chrome.runtime.onInstalled.addListener(function() {
	chrome.contextMenus.create({ "id": "copy_form", "title": "Copy Form", "contexts": ["editable"] });
	chrome.contextMenus.create({ "id": "paste_form", "title": "Paste Form", "contexts": ["editable"], enabled: false });
	chrome.contextMenus.create({ "id": "paste_form2", "title": "Paste Form (with Hidden)", "contexts": ["editable"], enabled: false });
});

chrome.contextMenus.onClicked.addListener(function(msg, tab) {
	switch (msg.menuItemId) {
		case "copy_form":
			copyFormContextMenu(tab);
			break;
		case "paste_form":
			pasteFormContextMenu(tab, false);
			break;
		case "paste_form2":
			pasteFormContextMenu(tab, true);
			break;
		default: break;
	}
});




function copyFormContextMenu(tab) {
	chrome.tabs.sendMessage(tab.id, { action: "copy" }, function(response) {
		try {
			chrome.storage.local.set({ 'clipboard': JSON.stringify(response) },function() {
				chrome.contextMenus.update("paste_form", { enabled: true });
			});
		} catch (err) {
			// Do nothing
		}
	});
}

function pasteFormContextMenu(tab, includeHiddenEl) {
	chrome.storage.local.get('clipboard', function(response) {
		try {
			const payload = {
				action: (includeHiddenEl === true ? "paste2" : "paste"),
				formData: JSON.parse(response.clipboard)
			};

			chrome.tabs.sendMessage(tab.id, payload);
		} catch (err) {
			// Do nothing
		}
	});
}